% ECE480: Project
% Winter 2004
% Chris Burtka - Lina Bazzi - T. Maria Pham
% April 14, 2004


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1) Record and save the phrase "We were away"
%    - Open the file in Matlab
%    - Create a labeled plot of the signal versus samples
%    - How many samples are in this sample?

% We are initializing for the file name
wavefile_CB1 = 'CB_WeWereAway1';

% This will read the file into Matlab as a one dimensional column array
[Y, Fs, WavBits] = wavread(wavefile_CB1)

% Results:
%        Fs =  22050
%   WavBits =  16

% Plays back the sound to verify the sound is good, comment after
%%%% sound(Y, Fs, WavBits)

% Plots y vs samples
figure(1)
plot(Y)
title('ECE480 Proj: Original Male - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% This will use the ginput to remove the pauses and silences at the beginning and end
% i.e. this truncates the signal
phrase = 'Click start and end coordinates';
% Shows the phrase in Matlab
display(phrase);
% Show pharse as title on plot
title(phrase);

% Use to get the coordiates of the two points where the signal will be truncated
% Note:  We will run the commands, then comment them after we have acquired the xcoord.

%%% [xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+004 *
%                               0.8399
%                               6.7085
%           ycoord =
%                              -0.1082
%                              -0.1082
% Converts the coordinates to an integer so that we can truncate the signal
%%% xcoord = round(xcoord);
% Will sort the x-coordinates in ascending order
%%% xcoord = sort(xcoord)
% Results:
%           xcoord =  8399  67085

%The following xcoord vector is a result of the above commands
xcoord = [8399 67085];

% truncates y (i.e. creates a Z vector that consist of the Y vector between the 2 selected
% x points.
z = Y(xcoord(1):xcoord(2));

% Plays the new truncated signal, will comment after signal is verified to be ok
%%%%sound(z,Fs)

% Plots Z vs samples
figure(2)
plot(z)
title('ECE480 Proj: Shortened Wave Data Male - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% This will give us the number of samples for the original signal
sizez = size(z)
% Results: sizeY =       58687         1

% Conclusion: There are 58687 samples in this signal

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2) Create a labeled plot of the signal versus time.  
%    What is the duration of this signal?

% We wil use the equation t = n/fs to find
n = [0:(sizez(1)-1)]';
t = n/Fs;

% Plots z vs time
figure(3)
% Multiply t by 1000 to make it into msec
plot(t*1000, z)
title('ECE480 Proj: Shortened Wave Data Male - We Were Away')
xlabel('Time, msec')
ylabel('Amplitude')

% Conclusion:  The duration of this signal is t = 2.6615 secs.  
%              - this was accomplished by printing out the t vector and taking the
%                last value

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3-6) Alter the signal so that its new sample rate is 11,025 kHz.
%    - How many samples are in this signal?

% down samples z to half as many samples
z = decimate(z,2)

% The new sampling rate (i.e. freq) is reduced to 1/2 Fs
Fsdec = Fs/2;

% Play decimated array to make sure it sounds very close to the original sound.
%sound(z, Fsdec, WavBits);

% This will take an array and create a wave file
wavwrite(z, Fsdec, WavBits, 'DownSampleCB1')

sizez = size(z)
% Results: sizez = 29344 

% Plots Z vs samples
figure(4)
plot(z)
title('ECE480 Proj: Down Sampled Wave Data Male - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% Conclusion: 
% - The sound after down sampling is still very close to the original 
% sound.  Our frequency is 11025 kHz, which is more than 2 times the speech bandwidth of 5kHz, 
% therefore the sound should not be noticebly affected.  11,025 kHz is sufficient.
% - One type of sound that would find this 11025 kHz to be insufficient would be for CD's, where
% the sampling frequency is 44 kHz (i.e. bandwidth = 22kHz).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 7: From the 11,025 Hz extract the utterance /IY/ from we

% Use to get the coordiates of the two points where the signal will be truncated
% Note:  We will run the commands, then comment them after we have acquired the xcoord.

%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+003 *
%                               2.2465
%                               7.4309
%           ycoord =
%                              -0.4167
%                              -0.3553
% Converts the coordinates to an integer so that we can truncate the signal
%%%%xcoord = round(xcoord);
% Will sort the x-coordinates in ascending order
%%%%xcoord = sort(xcoord)
% Results:
%           xcoord =  8399  67085

%The following xcoord vector is a result of the above commands
xcoord = [2247 7431];

% truncates y (i.e. creates a Z vector that consist of the Y vector between the 2 selected
% x points.
we = z(xcoord(1):xcoord(2));

% Plays the new truncated signal, will comment after signal is verified to be ok
%sound(we,Fsdec)

% This will take an array and create a wave file
wavwrite(we, Fsdec, WavBits, 'WeCB1')

sizewe = size(we)
% Results: sizewe = 5185 

% Plots we vs samples
figure(5)
plot(we)
title('ECE480 Proj: Down Sampled Wave Data Male - We')
xlabel('Samples, n')
ylabel('Amplitude')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 8: ZOom in on the /IY/ utterance.  
% - Does the signal look quasi-periodic?
% - Plot two 'periods' of the signal.  What is the approximate duration of one period in
%   seconds?  What frequency does this correspond to?

%zoom

%pause;

% Use to get the coordiates of the two points where the signal will be truncated
% [xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+003 *
%                               2.2199
%                               2.3014
%           ycoord =
%                              0.8824
%                              0.8824
% Converts the coordinates to an integer so that we can truncate the signal
%xcoord = round(xcoord);

xcoord = [2.2199 2.3014];

% This gives the period in samples
per_n = abs(xcoord(1)-xcoord(2))

% This gives the period in seconds
per_t = per_n/Fsdec

% Results (as we move from left to right on the signal): 
%          per_n = 86       81           79         73
%          per_t = 0.0078   0.0073       0.0072     0.0066

% Therefore, the average values are:
%          per_n = 79.75
%          per_t = 0.007225

freq = 1/per_t
% Results: freq = 138.41 Hz

% Plots we vs samples
figure(6)
plot(we)
title('ECE480 Proj: 2 Period of Down Sampled Wave Data Male - We')
xlabel('Samples, n')
ylabel('Amplitude')
axis([2040 2200 -1.25 1.25])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 9: From the 11,025 Hz extracting /eI/ from away

% Plots Z vs samples
figure(7)
plot(z)
title('ECE480 Proj: Down Sampled Wave Data Male - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% Use to get the coordiates of the two points where the signal will be truncated
% Note:  We will run the commands, then comment them after we have acquired the xcoord.

%%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+004 *
%                               2.4988
%                               2.9343
%           ycoord =
%                              0.2061
%                              0.2061
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%xcoord = round(xcoord);
% Will sort the x-coordinates in ascending order
%%%%%xcoord = sort(xcoord)
% Results:
%           xcoord =  24988  29343

%The following xcoord vector is a result of the above commands
xcoord = [ 24988 29343];

% truncates y (i.e. creates a Z vector that consist of the Y vector between the 2 selected
% x points.
away = z(xcoord(1):xcoord(2));

% Plays the new truncated signal, will comment after signal is verified to be ok
%%%%%sound(away,Fsdec)

% This will take an array and create a wave file
wavwrite(away, Fsdec, WavBits, 'awayCB1')

sizeaway = size(away)
% Results: sizeAway = 4356  

% Plots Away vs samples
figure(8)
plot(away)
title('ECE480 Proj: Down Sampled Wave Data Male - Away')
xlabel('Samples, n')
ylabel('Amplitude')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 10: Zoom in on the /dI/ utterance.  
% - Does the signal look quasi-periodic?
% - Plot two 'periods' of the signal.  What is the approximate duration of one period in
%   seconds?  What frequency does this correspond to?

%%zoom

%%pause;

% Use to get the coordiates of the two points where the signal will be truncated
%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =           717.7672
%                              819.4708
%           ycoord =
%                              0.9887
%                              0.9823
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%xcoord = round(xcoord);

xcoord = [718 819];

% This gives the period in samples
per_n = abs(xcoord(1)-xcoord(2))

% This gives the period in seconds
per_t = per_n/Fsdec

% Results (as we move from left to right on the signal): 
%          per_n = 101       106           110         113
%          per_t = 0.0092   0.0096       0.0100     0.0102

% Therefore, the average values are:
%          per_n = 107.5
%          per_t = 0.00975

freq = 1/per_t
% Results: freq = 102.56 Hz

% Plots we vs samples
figure(9)
plot(away)
title('ECE480 Proj: 4 Period of Down Sampled Wave Data Male - Away')
xlabel('Samples, n')
ylabel('Amplitude')
axis([1060 1490 -1.25 1.25])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 11) Resample the original 22,050 Hz "We were away" wave file in Matlab using 8 bits.

WavBit8 = 8;

% This will take an array and create a wave file
wavwrite(Y, Fs, WavBit8, 'CB_WeWereAway18bit')

% Plays the new truncated signal, will comment after signal is verified to be ok
sound(Y,Fs, WavBit8)

%Thought there were no perceivable differences between the two wave files, the actual 
%sound quality was lowered.  Fewever bits were used to encode the signal so 
%there is a larger quanitization error.