% ECE480: Project
% Winter 2004
% Chris Burtka - Lina Bazzi - T. Maria Pham
% April 14, 2004


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1) Record and save the phrase "We were away"
%    - Open the file in Matlab
%    - Create a labeled plot of the signal versus samples
%    - How many samples are in this sample?

% We are initializing for the file name
wavefile_LB1 = 'LB_WeWereAway2';

% This will read the file into Matlab as a one dimensional column array
[Y, Fs, WavBits] = wavread(wavefile_LB1);

% Results:
%        Fs =  22050
%   WavBits =  16

% Plays back the sound to verify the sound is good, comment after
%%%%%%%%%%%%%%sound(Y, Fs, WavBits)

% Plots y vs samples
figure(1)
plot(Y)
title('ECE480 Proj: Original Female - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% This will use the ginput to remove the pauses and silences at the beginning and end
% i.e. this truncates the signal
phrase = 'Click start and end coordinates';
% Shows the phrase in Matlab
display(phrase);
% Show phrase as title on plot
title(phrase);

% Use to get the coordiates of the two points where the signal will be truncated
% Note:  We will run the commands, then comment them after we have acquired the xcoord.

%%%%%%%%%%%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+004 *
%                               1.2442
%                               6.6636
%           ycoord =
%                              -0.0146
%                              -0.1023
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%%%%%%%%%%xcoord = round(xcoord);
% Will sort the x-coordinates in ascending order
%%%%%%%%%%%%%%xcoord = sort(xcoord)
% Results:
%           xcoord =  12442  66636

%The following xcoord vector is a result of the above commands
xcoord = [12442  66636];

% truncates y (i.e. creates a Z vector that consist of the Y vector between the 2 selected
% x points.
z = Y(xcoord(1):xcoord(2));

% Plays the new truncated signal, will comment after signal is verified to be ok
%%%%%%%%%%%%%%sound(z,Fs)

% Plots Z vs samples
figure(2)
plot(z)
title('ECE480 Proj: Shortened Wave Data Female - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% This will give us the number of samples for the original signal
sizez = size(z)
% Results: sizeY =       54195           1

% Conclusion: There are 54195 samples in this signal

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2) Create a labeled plot of the signal versus time.  
%    What is the duration of this signal?

% We wil use the equation t = n/fs to find
n = [0:(sizez(1)-1)]';
t = n/Fs;

% Plots z vs time
figure(3)
% Multiply t by 1000 to make it into msec
plot(t*1000, z)
title('ECE480 Proj: Shortened Wave Data Female - We Were Away')
xlabel('Time, msec')
ylabel('Amplitude')

% Conclusion:  The duration of this signal is t = 2.4578 secs.  
%              - this was accomplished by printing out the t vector and taking the
%                last value

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3-6) Alter the signal so that its new sample rate is 11,025 kHz.
%    - How many samples are in this signal?

% down samples z to half as many samples
z = decimate(z,2);

% The new sampling rate (i.e. freq) is reduced to 1/2 Fs
Fsdec = Fs/2;

% Play decimated array to make sure it sounds very close to the original sound.
%%%%%%%%%%%%%%sound(z, Fsdec, WavBits);

% This will take an array and create a wave file
wavwrite(z, Fsdec, WavBits, 'DownSampleLB1')

sizez = size(z)
% Results: sizez = 27098 

% Plots Z vs samples
figure(4)
plot(z)
title('ECE480 Proj: Down Sampled Wave Data Male - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% Conclusion: 
% - The sound after down sampling is still very close to the original 
% sound.  Our frequency is 11025 kHz, which is more than 2 times the speech bandwidth of 5kHz, 
% therefore the sound should not be noticebly affected.  11,025 kHz is sufficient.
% - One type of sound that would find this 11025 kHz to be insufficient would be for CD's, where
% the sampling frequency is 44 kHz (i.e. bandwidth = 22kHz).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 7: From the 11,025 Hz extract the utterance /IY/ from we

% Use to get the coordiates of the two points where the signal will be truncated
% Note:  We will run the commands, then comment them after we have acquired the xcoord.

%%%%%%%%%%%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+003 *
%                               2.3157
%                               5.4954
%           ycoord =
%                              0.0132
%                              0.1798
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%%%%%%%%%%xcoord = round(xcoord);
% Will sort the x-coordinates in ascending order
%%%%%%%%%%%%%%xcoord = sort(xcoord)
% Results:
%           xcoord =  2316  5495

%The following xcoord vector is a result of the above commands
xcoord = [2316  5495];

% truncates y (i.e. creates a Z vector that consist of the Y vector between the 2 selected
% x points.
we = z(xcoord(1):xcoord(2));

% Plays the new truncated signal, will comment after signal is verified to be ok
%%%%%%%%%%%%%%sound(we,Fsdec)

% This will take an array and create a wave file
wavwrite(we, Fsdec, WavBits, 'WeLB1')

sizewe = size(we)
% Results: sizewe = 3180 

% Plots we vs samples
figure(5)
plot(we)
title('ECE480 Proj: Down Sampled Wave Data Male - We')
xlabel('Samples, n')
ylabel('Amplitude')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 8: ZOom in on the /IY/ utterance.  
% - Does the signal look quasi-periodic?
% - Plot two 'periods' of the signal.  What is the approximate duration of one period in
%   seconds?  What frequency does this correspond to?

%%%%%%%%%%%%%%zoom

%%%%%%%%%%%%%%pause;

% Use to get the coordiates of the two points where the signal will be truncated
%%%%%%%%%%%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =            574.3273
%                               620.4475
%           ycoord =
%                              0.8953
%                              0.9092
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%%%%%%%%%%xcoord = round(xcoord)

xcoord = [574 620];

% This gives the period in samples
per_n = abs(xcoord(1)-xcoord(2))

% This gives the period in seconds
per_t = per_n/Fsdec

% Results (as we move from left to right on the signal): 
%          per_n =  46       45           45         43
%          per_t = 0.0042   0.0041      0.0041     0.0039

% Therefore, the average values are:
%          per_n = 44.75
%          per_t = 0.00408

%%%%%%%%%%%%%%freq = 1/per_t
% Results: freq = 245.098 Hz

% Plots we vs samples
figure(6)
plot(we)
title('ECE480 Proj: 2 Period of Down Sampled Wave Data Female - We')
xlabel('Samples, n')
ylabel('Amplitude')
axis([2050 2140 -1.25 1.25])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 9: From the 11,025 Hz extract the utterance /eI/ from away

% Plots Z vs samples
figure(7)
plot(z)
title('ECE480 Proj: Down Sampled Wave Data Female - We Were Away')
xlabel('Samples, n')
ylabel('Amplitude')

% Use to get the coordiates of the two points where the signal will be truncated
% Note:  We will run the commands, then comment them after we have acquired the xcoord.

%%%%%%%%%%%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =  1.0e+004 *
%                               2.3537
%                               2.6993
%           ycoord =
%                              -0.2851
%                              0.1360
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%%%%%%%%%%xcoord = round(xcoord);
% Will sort the x-coordinates in ascending order
%%%%%%%%%%%%%%xcoord = sort(xcoord)
% Results:
%           xcoord =  23537  26993

%The following xcoord vector is a result of the above commands
xcoord = [23537  26993];

% truncates y (i.e. creates a Z vector that consist of the Y vector between the 2 selected
% x points.
away = z(xcoord(1):xcoord(2));

% Plays the new truncated signal, will comment after signal is verified to be ok
%%%%%%%%%%%%%%sound(away,Fsdec)

% This will take an array and create a wave file
wavwrite(away, Fsdec, WavBits, 'awayLB1')

sizeaway = size(away)
% Results: sizeAway = 3457  

% Plots Away vs samples
figure(8)
plot(away)
title('ECE480 Proj: Down Sampled Wave Data Female - Away')
xlabel('Samples, n')
ylabel('Amplitude')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Part 10: Zoom in on the /dI/ utterance.  
% - Does the signal look quasi-periodic?
% - Plot two 'periods' of the signal.  What is the approximate duration of one period in
%   seconds?  What frequency does this correspond to?

%%%%%%%%%%%%%%zoom

%%%%%%%%%%%%%%pause;

% Use to get the coordiates of the two points where the signal will be truncated
%%%%%%%%%%%%%%[xcoord, ycoord] = ginput(2)
% Results:
%           xcoord =           268.6840
%                              322.7758
%           ycoord =

%                              1.0333
%                              1.0390
% Converts the coordinates to an integer so that we can truncate the signal
%%%%%%%%%%%%%%xcoord = round(xcoord);

xcoord = [269 323];

% This gives the period in samples
per_n = abs(xcoord(1)-xcoord(2))

% This gives the period in seconds
per_t = per_n/Fsdec

% Results (as we move from left to right on the signal): 
%          per_n = 54       54           59         62
%          per_t = 0.0049   0.0049       0.0054     0.0056

% Therefore, the average values are:
%          per_n = 57.25
%          per_t = 0.0052

%freq = 1/per_t
% Results: freq = 192.3 Hz

% Plots we vs samples
figure(9)
plot(away)
title('ECE480 Proj: 4 Period of Down Sampled Wave Data Female - Away')
xlabel('Samples, n')
ylabel('Amplitude')
axis([1160 1389 -1.25 1.25])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 11) Resample the original 22,050 Hz "We were away" wave file in Matlab using 8 bits.

WavBit8 = 8;

% This will take an array and create a wave file
wavwrite(Y, Fs, WavBit8, 'CB_WeWereAway18bit')

% Plays the new truncated signal, will comment after signal is verified to be ok
sound(Y,Fs, WavBit8)

%Thought there were no perceivable differences between the two wave files, the actual 
%sound quality was lowered.  Fewever bits were used to encode the signal so 
%there is a larger quanitization error.